import { HTMLAttributes, VNode } from "vue";
declare type align = "left" | "center" | "right";
export interface row {
    [key: string]: any;
}
interface renderParam<TableData> {
    row: TableData;
    column: TableComponent.Columns<TableData>;
    index: number;
}
export declare namespace TableComponent {
    interface Columns<TableData> {
        /**列头名字 */
        title?: string;
        /**列字段 */
        key?: keyof TableData;
        /**对齐方式*/
        align?: align;
        /**列宽 */
        width?: number;
        /**自定义渲染,类似vue的render函数 */
        render?: (param: renderParam<TableData>) => JSX.Element | string | number | VNode;
        /**自定义表头 */
        renderHeader?: (param: Omit<renderParam<TableData>, "row">) => JSX.Element | string | number | VNode;
        /**列class */
        className?: HTMLAttributes["class"];
        /**单元格class */
        cellClassName?: HTMLAttributes["class"];
        /**表头单元格class */
        cellHeaderClassName?: HTMLAttributes["class"];
        /**开启排序 */
        sortable?: boolean;
        /**表格类型 */
        type?: "" | "selection";
    }
}
declare type ExpandFunction = (param: {
    row: row;
    index: number;
}) => any;
export declare type ExpandRender = string | ExpandFunction;
export declare type SortType = "up" | "down" | "";
export interface SortConfig {
    /**排序类型*/
    type: SortType;
    /**排序的key */
    key: string;
    /**若没有key则使用index */
    columnIndex: number;
}
export interface TableEmitsLoad {
    ExportToExcel(): void;
}
declare type GetTableRef = () => HTMLTableElement | undefined;
export interface TabelBodyEmitsLoadInput {
    GetTableRef: GetTableRef;
}
export interface TabelHeaderEmitsLoadInput {
    GetTableRef: GetTableRef;
}
export {};
